!!ARBfp1.0

OUTPUT output = result.color;
TEMP base, bump, gloss, lVect, viewV, atten;
TEMP diffuse, specular, temp, invLen, shadow, dist;

PARAM amb  = program.local[0];
PARAM lCol = program.local[1];

PARAM attParams = { 1.0, 0.0, 0.000005, 0.0 };
PARAM extract = { 1.0, 0.00390625, 0.0000152587890625, 0.000000059604644775390625 };

PARAM specExp = 32.0;

TEX		base,   fragment.texcoord[0], texture[0], 2D;
TEX		bump,   fragment.texcoord[0], texture[1], 2D;
TEX		gloss,  fragment.texcoord[0], texture[2], 2D;

TEX		shadow, fragment.texcoord[3], texture[3], CUBE;

MAD		bump, bump, 2.0, -1.0;                               # Scale and bias

DP3		dist.w, fragment.texcoord[3], fragment.texcoord[3];
RSQ		dist.x, dist.w;
MUL		dist, dist.x, dist.w;

DP4		shadow, shadow, extract;

ADD		shadow, shadow.x, 0.003;
SGE		shadow, shadow, dist;

DP3		bump.w, bump, bump;                                  # Post-filter normalisation of bumpmap
RSQ		bump.w, bump.w;
MUL		bump,   bump, bump.w;

DP3		temp,   fragment.texcoord[1], fragment.texcoord[1];  # Normalize light vector
RSQ		invLen, temp.x;
MUL		lVect,  fragment.texcoord[1], invLen;

DST		atten, temp,  invLen;                                # Attenuation
DP3		atten, atten, attParams;
RCP		atten, atten.x;

DP3_SAT	diffuse, lVect, bump;                                # Diffuse

DP3		temp,   fragment.texcoord[2], fragment.texcoord[2];  # Normalize view vector
RSQ		invLen, temp.x;
MUL		viewV,  fragment.texcoord[2], invLen;

DP3		temp,  lVect, bump;                                  # Reflection vector
MUL		temp,  temp,  bump;
MAD		lVect,  temp,  2.0, -lVect;

DP3_SAT	specular, lVect, viewV;                              # Specular

POW		specular, specular.x, specExp.x;
MUL		specular, specular, gloss;

MAD		diffuse, diffuse, base, specular;                    # Ambient * Base + (Diffuse * Base + Specular) * Attenuation
MUL		diffuse, diffuse, shadow;
MUL		temp, base, amb;
MUL		diffuse, diffuse, lCol;
MAD		output, diffuse, atten, temp;



  
END 
